# Chione

home
: https://faelidth.org/chione

code
: https://hg.sr.ht/~ged/chione

github
: https://github.com/ged/chione

docs
: https://faelidth.org/chione/docs


## Description

An Entity/Component System framework inspired by Artemis.

This library is still experimental. I am writing it by extracting out ideas from
a multi-user game I'm working on, and things may change radically if I find
that parts of it don't work or could be done a better way.

That said, let me know if you're using it for anything and I'll try to keep
you abreast of any changes I'm considering, and I'm happy to chat about ideas
for making it better via email or whatever.


## Prerequisites

* Ruby 3.0+


## Installation

    $ gem install chione


## Resources

Articles/posts on ECS:

* <http://gameprogrammingpatterns.com/component.html>
* <http://t-machine.org/index.php/2007/09/03/entity-systems-are-the-future-of-mmog-development-part-1/>
* <http://www.richardlord.net/blog/what-is-an-entity-framework>
* <http://www.richardlord.net/blog/why-use-an-entity-framework>
* <http://cowboyprogramming.com/2007/01/05/evolve-your-heirachy/>
* <https://dzone.com/articles/entity-component-systems-in-elixir>

Other ECS Frameworks:

* <https://github.com/junkdog/artemis-odb> (Java)
* <http://www.richardlord.net/ash/> (ActionScript)
* <https://github.com/libgdx/ashley> (Java)
* <https://github.com/astrosilverio/braga> (Python)
* <https://github.com/seanfisk/ecs> (Python)
* <https://github.com/tdavies/Ember2> (ActionScript)
* <https://github.com/cpowell/ruby-entity-component-framework> (JRuby)
* <https://github.com/alecmce/xember> (ActionScript)

## Contributing

You can check out the current development source with Mercurial via its
[project page][sourcehut]. Or if you prefer Git, via
[its Github mirror][github].

After checking out the source, run:

    $ rake newb

This task will install any missing dependencies, run the tests/specs,
and generate the API documentation.


## Authors

- Michael Granger <ged@faeriemud.org>


## License

Copyright (c) 2015-2023, Michael Granger
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of the author/s, nor the names of the project's
  contributors may be used to endorse or promote products derived from this
  software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


[github]: https://github.com/ged/chione
[sourcehut]: https://sr.ht/~ged/chione

